// Generated for IBM Rational Tau 4.3.0.0.15181 at Tue Sep 29 16:06:22 CEST 2009
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2009.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#include "torPlatform.h"

#include "torThread.h"

namespace
{
    int launch_helper(void *arg)
    {
        if (arg == 0)
            return -1;

        using namespace tor::os::Thread;
        
        Behaviour *behaviour = static_cast<Behaviour *>(arg);
        bool bDeleteOnTerminate = behaviour->deleteOnTerminate();
        int status = behaviour->execute();

        if (bDeleteOnTerminate)
            delete behaviour;

        return status;
    }
}

namespace tor
{
    namespace os
    {
        namespace Thread
        {
            bool launch(Behaviour *toExecute)
            {
                return createThread(launch_helper, toExecute);
            }
        }
    }
}
